#include pdols.prg;
#include dsur.prg;
cls;
"______________________________________________________________________";
"         Cointegration Vector Estimation by Panel DOLS and            ";
"                   Dynamic Seemingly Unrelated Estimator              ";
"                                                                      ";
"       Nelson Mark             and         Donggy Sul                 ";
"      Mark.1@osu.edu                    d.SUL@auckland.ac.nz          ";
"                                                                      ";
"                   Current Version: V2.02, Feb, 2003                  ";
"                        D.SUL@Auckland.ac.nz                          ";
"                                                                      ";
"       This program has been used and seem to be free of errors.      ";
"       However, we (Nelson C. Mark, Masao Ogaki and Donggyu Sul)      ";
"       do not assume responsibility for any remainig errors.          ";
"       In no event shall we be liable to for any damages whatsoever   ";
"       arising out of the use of or inability to use this program.    ";
"                                                                      ";
"       References                                                     ";
"       Mark and Sul, 2002, Cointegration Estimation by Panel          ";
"        Dols and Long Run Money Demand                                ";
"                                                                      ";
"       Mark, Ogaki, and Sul, 2003, Dynamic Seemingly Uncorrelated     ";
"        Cointegration Regression                                      ";
"                                                                      ";
"                       PRESS ANY KEY TO CONTINUE                      ";
"______________________________________________________________________";
wait;
cls;
kkk:
"______________________________________________________________________";
"                                                                      ";
"                                                                      ";
"                                                                      ";
"                                                                      ";
"                 ESTIMATION FOR COINTEGRATION VECTOR                  ";
"                                                                      ";
"                                                                      ";
"                                                                      ";
"               Choice of The number of Leads and Lags                 ";
"                           Recommendations:                           ";
"                                                                      ";
"                                                                      ";
"                 T less than 30:   p = 1                              ";
"                 T around 50:      p = 2                              ";
"                 T around 100:     p = 3                              ";
"                 T around 200:     p = 4                              ";
"                                                                      ";
"                                                                      ";
"                        Please type your choice                       ";
"______________________________________________________________________";
"                                                                      ";
p = con(1,1);
cls;
"______________________________________________________________________";
"                                                                      ";
"                                                                      ";
"                                                                      ";
"                                                                      ";
"               Cross Sectional Dependence Analysis                    ";
"                                                                      ";
"                                                                      ";
"                                                                      ";
"                  Choice of a Model (Example: 2 regressors)           ";
"                                                                      ";
"     Model 1: No constant                                             ";
"              y_it = c1(i) x_it + c2(i) z_it + u_it                   ";
"                                                                      ";
"     Model 2: With constant                                           ";
"              y_it = a_i + c1(i) x_it + c2(i) z_it + u_it             ";
"                                                                      ";
"     Model 3: With constant and heterogenous linear trend             ";
"              y_it = a_i + b_i t + c1(i) x_it + c2(i) z_it + u_it     ";
"                                                                      ";
"                        Please type your choice                       ";
"______________________________________________________________________";

icase = con(1,1);
cls;
output on;
if ivar == 1; b = csdan1(y,x1,p,f,icase); endif;
if ivar == 2; b = csdan2(y,x1,x2,p,f,icase); endif;
if ivar == 3; b = csdan3(y,x1,x2,x3,p,f,icase); endif;
if ivar == 4; b = csdan4(y,x1,x2,x3,x4,p,f,icase); endif;
if ivar == 5; b = csdan5(y,x1,x2,x3,x4,x5,p,f,icase); endif;

output off;

if cols(b) < cols(y); 
      "Do you want to use the selected countries (or individuals)?";
      "(1) Yes";
      "(2) No. I want to use all individuals with common time effect(PDOLS)";
      "(3) No. I want to select the subgroup myself";
      ki1 = con(1,1);
if ki1 == 1;     
 if ivar == 1; y = y[.,b]; x1 = x1[.,b]; endif;
 if ivar == 2; y = y[.,b]; x1 = x1[.,b]; x2 = x2[.,b]; endif;
 if ivar == 3; y = y[.,b]; x1 = x1[.,b]; x2 = x2[.,b]; x3 = x3[.,b]; endif;
 if ivar == 4; y = y[.,b]; x1 = x1[.,b]; x2 = x2[.,b]; x3 = x3[.,b]; x4 = x4[.,b]; endif;
 if ivar == 5; y = y[.,b]; x1 = x1[.,b]; x2 = x2[.,b]; x3 = x3[.,b]; x4 = x4[.,b]; x5 = x5[.,b]; endif;

goto dsur; 
endif;

if ki1 == 2;
goto pdols00;
endif;

if ki1 == 3;
cls;
"Press Esc to stop the program";
endif;


pdols00:
"______________________________________________________________________";
"                                                                      ";
"                                                                      ";
"                                                                      ";
"                                                                      ";
"                ESTIMATION FOR COINTEGRATION VECTOR                   ";
"                                                                      ";
"                                                                      ";
"                                                                      ";
"                           Choice of a Model                          ";
"                                                                      ";
"     Model 1: No constant                                             ";
"              y_it = c1 x_it + c2 z_it + u_it                         ";
"                                                                      ";
"     Model 2: With constant(Fixed effect)                             ";
"              y_it = a_i + c1 x_it + c2 z_it + u_it                   ";
"                                                                      ";
"     Model 3: With constant and heterogenous linear trend             ";
"              y_it = a_i + b_i t + c1 x_it + c2 z_it + u_it           ";
"                                                                      ";
"                        Please type your choice                       ";
"______________________________________________________________________";
"                                                                      ";
icase = con(1,1);
cls;
output on;
if ivar == 1; b = pdols1(y,x1,p,icase); endif;
if ivar == 2; b = pdols2(y,x1,x2,p,icase); endif;
if ivar == 3; b = pdols3(y,x1,x2,x3,p,icase); endif;
if ivar == 4; b = pdols4(y,x1,x2,x3,x4,p,icase); endif;
if ivar == 5; b = pdols5(y,x1,x2,x3,x4,x5,p,icase); endif;
output off;

"Do you want to change the number of leads and lags? Yes(1) NO(2)";
kk = con(1,1);
if kk == 1; goto kkk; endif;

if kk == 2; cls;
"Do you want to use Dynamic Seemingly Unrelated Regression for Testing";
"Homogeneity as well as Estimation? Yes(1) No(2)";
kk2 = con(1,1);
 if kk2 == 1; goto dsur; endif;
 if kk2 == 2;
  "press Esc to stop the program";endif;
endif;

dsur:
cls;

df = ivar*(2*p+3) + int((cols(y)-1)/2) + 2*p + 1;
if df >= rows(y) - 10;
"Warning: Degrees of Freedom is very low"; 
endif;
if df >= rows(y) - 3;
"Warning: Degrees of Freedom is too low"; 
endif;
cls;

"______________________________________________________________________";
"                                                                      ";
"                                                                      ";
"                                                                      ";
"                                                                      ";
"                ESTIMATION FOR COINTEGRATION VECTOR                   ";
"                           Homogeneity Test                           ";
"                    Under Cross Section Dependence                    ";
"                                                                      ";
"                                                                      ";
"                           Choice of a Model                          ";
"                                                                      ";
"                                                                      ";
"     Model 1: No constant                                             ";
"              y_it = c1(i) x_it + c2(i) z_it + u_it                   ";
"                                                                      ";
"     Model 2: With constant                                           ";
"              y_it = a_i + c1(i) x_it + c2(i) z_it + u_it             ";
"                                                                      ";
"     Model 3: With constant and heterogenous linear trend             ";
"              y_it = a_i + b_i t + c1(i) x_it + c2(i) z_it + u_it     ";
"                                                                      ";
"                        Please type your choice                       ";
"______________________________________________________________________";

icase = con(1,1);
cls;
output on;
if ivar == 1; b = dsur1(y,x1,p,f,icase); endif;
if ivar == 2; b = dsur2(y,x1,x2,p,f,icase); endif;
if ivar == 3; b = dsur3(y,x1,x2,x3,p,f,icase); endif;
if ivar == 4; b = dsur4(y,x1,x2,x3,x4,p,f,icase); endif;
if ivar == 5; b = dsur5(y,x1,x2,x3,x4,x5,p,f,icase); endif;

output off;

"Do you want to change the number of leads and lags? Yes(1) NO(2)";
kk = con(1,1);
if kk == 1; goto kkk; endif;

if kk == 2; cls;
 "Do you want to use Panel Dynamic OLS Estimator ";
 " with Common Time Effect? Yes(1) No(2)";
  kk2 = con(1,1);
   if kk2 == 1; goto pdols00; endif;
   if kk2 == 2;
   "press Esc to stop the program";
   endif;
endif;



endif;